/*
  1、此文件由自制NPM插件（wp-vuetojs）编译而成
  2、【wp-vuetojs】插件经npm安装（npm install -g wp-vuetojs）后，在指定目录运行【vuetojs】命令，可递归将目录下所有特定格式vue文件转化为一个js至本目录
  2、本文件不建议编辑，因为在【wp-vuetojs】运行后会监听目录下 新增、删除vue文件及代码，从而自动编译（报错会打印错误信息）
  3、vue文件名即为组件名，有大写是调用需使用(-小写字母)替代，因为html不区分大小写
  4、被同一html文件引用的组件之间，可以互相调用
  5、更多请关注 https://www.npmjs.com/package/wp-vuetojs
*/

function vuetojsAddClass(content) {
  let styleElement = document.getElementById("styleSelf");
  if (!styleElement) {
    styleElement = document.createElement("style");
    styleElement.type = "text/css";
    styleElement.id = "styleSelf";
    document.head.appendChild(styleElement);
  }
  let oldStyle = styleElement.innerText;
  styleElement.innerHTML = oldStyle+"\n"+content+"\n";
}
Vue.component("form-com-row", {
template:`<div data-form-com-row  class="form-row">
  <div class="labels" v-show="!hideLabel">
    {{ row.label }}
  </div>
  <div class="values">
    <form-com-select-color v-if="row.type == 'color'" :value="value" @input="onInput" @change="onchange"></form-com-select-color>
    <form-com-select-image v-else-if="row.type == 'image'" :value="value" @input="onInput" @change="onchange"></form-com-select-image>
    <el-switch v-else-if="row.type == 'boolean'" :value="value" @input="onInput" @change="onchange" @blur="onchange"></el-switch>
    <el-input-number class="selfNumber" v-else-if="row.type == 'number'" :value="value" @input="onInput" @blur="onchange" controls-position="right"></el-input-number>
    <el-select v-else-if="row.type == 'select'" :value="value" @input="onInput" @change="onchange">
      <el-option v-for="item in optionCom" :key="item.value" :label="item.label" :value="item.value"> </el-option>
    </el-select>
    <el-input v-else :value="value" @input="onInput" @change="onchange"></el-input>
  </div>
</div>`,
  props: ["row", "value", "hideLabel"],
  data() {
    return {

    }
  },
  computed: {
    optionCom() {
      let list = [];
      try {
        list = JSON.parse(this.row.enum)
      } catch (e) {
        //TODO handle the exception
      }
      return list;
    }
  },
  methods: {
    onInput(value) {
      if(value === undefined){
        this.$emit("input", undefined)
      }else{
        this.$emit("input", value)
      }
    },
    onchange(value) {
      this.$emit("change", value)
    }
  }
});
vuetojsAddClass(`[data-form-com-row].form-row {
  display: flex;
  width: 100%;
}
[data-form-com-row].form-row .labels {
  width: 100px;
  display: flex;
  align-items: center;
}
[data-form-com-row].form-row .values {
  flex: 1;
}
[data-form-com-row].form-row .values .el-input-number {
  width: 100%;
}
[data-form-com-row].form-row .values .el-input-number input {
  text-align: left;
}
[data-form-com-row].form-row .selfNumber .el-input-number__decrease,
[data-form-com-row].form-row .selfNumber .el-input-number__increase {
  display: none;
}`)